'use strict';

var _fs = require('fs');

var _fs2 = _interopRequireDefault(_fs);

var _ava = require('ava');

var _ava2 = _interopRequireDefault(_ava);

var _path = require('path');

var _path2 = _interopRequireDefault(_path);

var _webpack = require('webpack');

var _webpack2 = _interopRequireDefault(_webpack);

var _memoryFs = require('memory-fs');

var _memoryFs2 = _interopRequireDefault(_memoryFs);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

const testFixture = (fixture, options = {}) => {
  const compiler = (0, _webpack2.default)({
    entry: `./${fixture}`,
    output: {
      path: _path2.default.resolve(__dirname),
      filename: 'bundle.js'
    },
    externals: {
      'system-components': 'systemComponents'
    },
    module: {
      rules: [{
        test: /fixture.json$/,
        use: _path2.default.resolve(__dirname, './')
      }]
    }
  });

  compiler.outputFileSystem = new _memoryFs2.default();

  return new Promise((resolve, reject) => {
    compiler.run((err, stats) => {
      if (err) reject(err);

      resolve(stats);
    });
  });
};

(0, _ava2.default)('returns components', async t => {
  const stats = await testFixture('fixture.json');
  const json = stats.toJson();
  const src = json.modules[0].source;
  t.snapshot(src);
});
//# sourceMappingURL=/Users/jxnblk/repos/styled-system/loader/node_modules/.cache/ava/48238eaf5ae82e0a423676605e3c8a79.js.map