import arrayEach from 'fast-loops/lib/arrayEach';
import { RULE_TYPE } from 'fela-utils';

import rehydrateSupportRules from './rehydrateSupportRules';
import rehydrateRules from './rehydrateRules';

// rehydration (WIP)
// TODO: static, keyframe, font
export default function rehydrate(renderer) {
  arrayEach(document.querySelectorAll('[data-fela-type]'), function (node) {
    var rehydrationAttribute = node.getAttribute('data-fela-rehydration') || -1;
    var rehydrationIndex = parseInt(rehydrationAttribute);

    // skip rehydration if no rehydration index is set
    // this index is set to -1 if something blocks rehydration
    if (rehydrationIndex !== -1) {
      var type = node.getAttribute('data-fela-type') || '';
      var media = node.getAttribute('media') || '';
      var support = node.getAttribute('data-fela-support');
      var css = node.textContent;

      renderer.uniqueRuleIdentifier = rehydrationIndex;

      if (type === RULE_TYPE) {
        if (support) {
          rehydrateSupportRules(css, media, renderer.cache);
        } else {
          rehydrateRules(css, media, '', renderer.cache);
        }
      }
    }
  });
}