'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

exports.default = connectDOMNodes;

var _objectEach = require('fast-loops/lib/objectEach');

var _objectEach2 = _interopRequireDefault(_objectEach);

var _arrayEach = require('fast-loops/lib/arrayEach');

var _arrayEach2 = _interopRequireDefault(_arrayEach);

var _felaUtils = require('fela-utils');

var _initDOMNode = require('./initDOMNode');

var _initDOMNode2 = _interopRequireDefault(_initDOMNode);

var _findDOMNodes = require('./findDOMNodes');

var _findDOMNodes2 = _interopRequireDefault(_findDOMNodes);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function connectDOMNodes(renderer) {
  renderer.nodes = (0, _findDOMNodes2.default)();

  var cacheCluster = (0, _felaUtils.clusterCache)(renderer.cache, renderer.mediaQueryOrder, renderer.supportQueryOrder);

  var baseNode = renderer.nodes[_felaUtils.RULE_TYPE];

  (0, _objectEach2.default)(_felaUtils.sheetMap, function (type, key) {
    if (cacheCluster[key].length > 0) {
      (0, _initDOMNode2.default)(renderer.nodes, baseNode, cacheCluster[key], type);
    }
  });

  var support = (0, _felaUtils.cssifySupportRules)(cacheCluster.supportRules);

  if (support) {
    (0, _initDOMNode2.default)(renderer.nodes, baseNode, support, _felaUtils.RULE_TYPE, '', true);
  }

  var mediaKeys = Object.keys(_extends({}, cacheCluster.supportMediaRules, cacheCluster.mediaRules));

  (0, _arrayEach2.default)(mediaKeys, function (media) {
    if (cacheCluster.mediaRules[media] && cacheCluster.mediaRules[media].length > 0) {
      (0, _initDOMNode2.default)(renderer.nodes, baseNode, cacheCluster.mediaRules[media], _felaUtils.RULE_TYPE, media);
    }

    if (cacheCluster.supportMediaRules[media]) {
      var mediaSupport = (0, _felaUtils.cssifySupportRules)(cacheCluster.supportMediaRules[media]);

      if (mediaSupport.length > 0) {
        (0, _initDOMNode2.default)(renderer.nodes, baseNode, mediaSupport, _felaUtils.RULE_TYPE, media, true);
      }
    }
  });
}